Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/physiq.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/physiq.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/physiq.F90	(revision 227)
@@ -1503,13 +1535,13 @@
 	 
 
-            pdq(1:ngrid,1:nlayermx,1:nq) = pdq(1:ngrid,1:nlayermx,1:nq) + zdqmr(1:ngrid,1:nlayermx,1:nq)
+            pdq(1:ngrid,1:nlayer,1:nq) = pdq(1:ngrid,1:nlayer,1:nq) + zdqmr(1:ngrid,1:nlayer,1:nq)
             dqsurf(1:ngrid,1:nq)         = dqsurf(1:ngrid,1:nq) + zdqsurfmr(1:ngrid,1:nq)
-            pdt(1:ngrid,1:nlayermx)        = pdt(1:ngrid,1:nlayermx) + zdtmr(1:ngrid,1:nlayermx)
-            pdu(1:ngrid,1:nlayermx)        = pdu(1:ngrid,1:nlayermx) + zdumr(1:ngrid,1:nlayermx)
-            pdv(1:ngrid,1:nlayermx)        = pdv(1:ngrid,1:nlayermx) + zdvmr(1:ngrid,1:nlayermx)
+            pdt(1:ngrid,1:nlayer)        = pdt(1:ngrid,1:nlayer) + zdtmr(1:ngrid,1:nlayer)
+            pdu(1:ngrid,1:nlayer)        = pdu(1:ngrid,1:nlayer) + zdumr(1:ngrid,1:nlayer)
+            pdv(1:ngrid,1:nlayer)        = pdv(1:ngrid,1:nlayer) + zdvmr(1:ngrid,1:nlayer)
 	    pdpsrf(1:ngrid)                = pdpsrf(1:ngrid) + zdpsrfmr(1:ngrid)
             zdtsurf(1:ngrid)               = zdtsurf(1:ngrid) + zdtsurfmr(1:ngrid)
 	    
-!	    print*,'after mass redistrib, q=',pq(211,1:nlayermx,igcm_h2o_vap)+ptimestep*pdq(211,1:nlayermx,igcm_h2o_vap) 
+!	    print*,'after mass redistrib, q=',pq(211,1:nlayer,igcm_h2o_vap)+ptimestep*pdq(211,1:nlayer,igcm_h2o_vap) 
 	 endif
 
@@ -1672,14 +1704,14 @@
  
       ! temperature, zonal and meridional wind
-      zt(1:ngrid,1:nlayermx) = pt(1:ngrid,1:nlayermx) + pdt(1:ngrid,1:nlayermx)*ptimestep
-      zu(1:ngrid,1:nlayermx) = pu(1:ngrid,1:nlayermx) + pdu(1:ngrid,1:nlayermx)*ptimestep
-      zv(1:ngrid,1:nlayermx) = pv(1:ngrid,1:nlayermx) + pdv(1:ngrid,1:nlayermx)*ptimestep
+      zt(1:ngrid,1:nlayer) = pt(1:ngrid,1:nlayer) + pdt(1:ngrid,1:nlayer)*ptimestep
+      zu(1:ngrid,1:nlayer) = pu(1:ngrid,1:nlayer) + pdu(1:ngrid,1:nlayer)*ptimestep
+      zv(1:ngrid,1:nlayer) = pv(1:ngrid,1:nlayer) + pdv(1:ngrid,1:nlayer)*ptimestep
 
       ! diagnostic
-      zdtdyn(1:ngrid,1:nlayermx)     = pt(1:ngrid,1:nlayermx)-ztprevious(1:ngrid,1:nlayermx)
-      ztprevious(1:ngrid,1:nlayermx) = zt(1:ngrid,1:nlayermx)
+      zdtdyn(1:ngrid,1:nlayer)     = pt(1:ngrid,1:nlayer)-ztprevious(1:ngrid,1:nlayer)
+      ztprevious(1:ngrid,1:nlayer) = zt(1:ngrid,1:nlayer)
 
       if(firstcall)then
-         zdtdyn(1:ngrid,1:nlayermx)=0.0
+         zdtdyn(1:ngrid,1:nlayer)=0.0
       endif
 
@@ -1690,5 +1722,5 @@
 
       ! tracers
-      zq(1:ngrid,1:nlayermx,1:nq) = pq(1:ngrid,1:nlayermx,1:nq) + pdq(1:ngrid,1:nlayermx,1:nq)*ptimestep
+      zq(1:ngrid,1:nlayer,1:nq) = pq(1:ngrid,1:nlayer,1:nq) + pdq(1:ngrid,1:nlayer,1:nq)*ptimestep
 
       ! surface pressure
@@ -1798,5 +1830,5 @@
          do iq=1,nq
            do ig=1,ngrid
-              qcol(ig,iq) = SUM( zq(ig,1:nlayermx,iq) * mass(ig,1:nlayermx))
+              qcol(ig,iq) = SUM( zq(ig,1:nlayer,iq) * mass(ig,1:nlayer))
            enddo
          enddo
@@ -1805,14 +1837,14 @@
          reffcol(1:ngrid,1:naerkind)=0.0
          if(co2cond.and.(iaero_co2.ne.0))then
-            call co2_reffrad(ngrid,nq,zq,reffrad(1,1,iaero_co2))
+            call co2_reffrad(ngrid,nlayer,nq,zq,reffrad(1,1,iaero_co2))
             do ig=1,ngrid
-               reffcol(ig,iaero_co2) = SUM(zq(ig,1:nlayermx,igcm_co2_ice)*reffrad(ig,1:nlayermx,iaero_co2)*mass(ig,1:nlayermx))
+               reffcol(ig,iaero_co2) = SUM(zq(ig,1:nlayer,igcm_co2_ice)*reffrad(ig,1:nlayer,iaero_co2)*mass(ig,1:nlayer))
             enddo
          endif
          if(water.and.(iaero_h2o.ne.0))then
-            call h2o_reffrad(ngrid,zq(1,1,igcm_h2o_ice),zt, &
+            call h2o_reffrad(ngrid,nlayer,zq(1,1,igcm_h2o_ice),zt, &
                              reffrad(1,1,iaero_h2o),nueffrad(1,1,iaero_h2o))
             do ig=1,ngrid
-               reffcol(ig,iaero_h2o) = SUM(zq(ig,1:nlayermx,igcm_h2o_ice)*reffrad(ig,1:nlayermx,iaero_h2o)*mass(ig,1:nlayermx))
+               reffcol(ig,iaero_h2o) = SUM(zq(ig,1:nlayer,igcm_h2o_ice)*reffrad(ig,1:nlayer,iaero_h2o)*mass(ig,1:nlayer))
             enddo
          endif
@@ -1989,5 +2021,5 @@
               end do
             if (water) then
-               vmr=zq(1:ngrid,1:nlayermx,igcm_h2o_vap)*mugaz/mmol(igcm_h2o_vap)
+               vmr=zq(1:ngrid,1:nlayer,igcm_h2o_vap)*mugaz/mmol(igcm_h2o_vap)
                call wstats(ngrid,"vmr_h2ovapor",                           &
                           "H2O vapour volume mixing ratio","mol/mol",       & 
@@ -2183,6 +2215,10 @@
 
         ! deallocate gas variables
+!$OMP BARRIER
+!$OMP MASTER
         IF ( ALLOCATED( gnom ) ) DEALLOCATE( gnom )
         IF ( ALLOCATED( gfrac ) ) DEALLOCATE( gfrac )  ! both allocated in su_gases.F90
+!$OMP END MASTER
+!$OMP BARRIER
 
         ! deallocate saved arrays
@@ -2203,4 +2239,5 @@
         IF ( ALLOCATED(q2)) DEALLOCATE(q2)
         IF ( ALLOCATED(ztprevious)) DEALLOCATE(ztprevious)
+	IF ( ALLOCATED(hice)) DEALLOCATE(hice)
         IF ( ALLOCATED(cloudfrac)) DEALLOCATE(cloudfrac)
         IF ( ALLOCATED(totcloudfrac)) DEALLOCATE(totcloudfrac)
@@ -2223,4 +2260,10 @@
         IF ( ALLOCATED(zdtsw)) DEALLOCATE(zdtsw)
         IF ( ALLOCATED(tau_col)) DEALLOCATE(tau_col)
+	IF ( ALLOCATED(pctsrf_sic)) DEALLOCATE(pctsrf_sic)
+        IF ( ALLOCATED(tslab)) DEALLOCATE(tslab)
+        IF ( ALLOCATED(tsea_ice)) DEALLOCATE(tsea_ice)
+        IF ( ALLOCATED(sea_ice)) DEALLOCATE(sea_ice)
+        IF ( ALLOCATED(zmasq)) DEALLOCATE(zmasq)
+        IF ( ALLOCATED(knindex)) DEALLOCATE(knindex)
 
         !! this is defined in comsaison_h
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/planete_mod.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/planete_mod.F90	(revision 227)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/planete_mod.F90	(revision 227)
@@ -0,0 +1,45 @@
+MODULE planete_mod
+  IMPLICIT NONE
+  
+  REAL :: apoastr ! maximum star-planet distance (AU)
+  REAL :: periastr ! minimum star-planet distance (AU)
+  REAL :: year_day ! length of year (sols)
+  REAL :: peri_day ! date of periastron (sols since N. spring)
+  REAL :: obliquit ! Obliquity of the planet (deg)
+  REAL :: nres ! tidal resonance ratio
+  REAL :: z0 ! surface roughness (m)
+  REAL :: lmixmin ! mixing length
+  REAL :: emin_turb ! minimal energy
+  REAL :: coefvis
+  REAL :: coefir
+  REAL :: timeperi
+  REAL :: e_elips
+  REAL :: p_elips
+  
+  REAL :: preff ! reference surface pressure (Pa)	!read by master
+  REAL,ALLOCATABLE :: ap(:) ! hybrid coordinate at layer interface	!read by master
+  REAL,ALLOCATABLE :: bp(:) ! hybrid coordinate at layer interface 	!read by master
+  
+  CONTAINS
+  
+  subroutine ini_planete_mod(nlayer,preff_dyn,ap_dyn,bp_dyn)
+  
+  implicit none
+  integer,intent(in) :: nlayer ! number of atmospheric layers
+  real,intent(in) :: preff_dyn ! reference surface pressure (Pa)
+  real,intent(in) :: ap_dyn(nlayer+1) ! hybrid coordinate at interfaces
+  real,intent(in) :: bp_dyn(nlayer+1) ! hybrid coordinate at interfaces
+  
+!$OMP MASTER
+  allocate(ap(nlayer+1))
+  allocate(bp(nlayer+1))
+  
+  preff=preff_dyn
+  ap(:)=ap_dyn(:)
+  bp(:)=bp_dyn(:)
+!$OMP END MASTER
+!$OMP BARRIER
+  
+  end subroutine ini_planete_mod
+  
+END MODULE planete_mod
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/radcommon_h.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/radcommon_h.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/radcommon_h.F90	(revision 227)
@@ -61,14 +61,19 @@
 ! gIR      :  mean assymetry factor
 
-      REAL*8 BWNI(L_NSPECTI+1), WNOI(L_NSPECTI), DWNI(L_NSPECTI), WAVEI(L_NSPECTI)
-      REAL*8 BWNV(L_NSPECTV+1), WNOV(L_NSPECTV), DWNV(L_NSPECTV), WAVEV(L_NSPECTV)
+      REAL*8 BWNI(L_NSPECTI+1), WNOI(L_NSPECTI), DWNI(L_NSPECTI), WAVEI(L_NSPECTI) !BWNI read by master in setspi
+      REAL*8 BWNV(L_NSPECTV+1), WNOV(L_NSPECTV), DWNV(L_NSPECTV), WAVEV(L_NSPECTV) !BWNV read by master in setspv
       REAL*8 STELLARF(L_NSPECTV), TAURAY(L_NSPECTV), TAURAYVAR(L_NSPECTV)
+!$OMP THREADPRIVATE(WNOI,DWNI,WAVEI,&
+	!$OMP WNOV,DWNV,WAVEV,&
+	!$OMP STELLARF,TAURAY,TAURAYVAR)
 
       REAL*8 blami(L_NSPECTI+1)
       REAL*8 blamv(L_NSPECTV+1) ! these are needed by suaer.F90
+!$OMP THREADPRIVATE(blami,blamv)
 
       !! AS: introduced to avoid doing same computations again for continuum
       INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: indi
       INTEGER, DIMENSION(:,:,:), ALLOCATABLE :: indv
+!$OMP THREADPRIVATE(indi,indv)
 
       !!! ALLOCATABLE STUFF SO THAT DIMENSIONS ARE READ in *.dat FILES -- AS 12/2011  
@@ -79,4 +84,6 @@
       real*8 pgasmin, pgasmax
       real*8 tgasmin, tgasmax
+!$OMP THREADPRIVATE(gasi,gasv,&  !wrefvar,pgasref,tgasref,pfgasref read by master in sugas_corrk
+	!$OMP FZEROI,FZEROV)     !pgasmin,pgasmax,tgasmin,tgasmax read by master in sugas_corrk
 
       real QVISsQREF(L_NSPECTV,naerkind,nsizemax)
@@ -86,4 +93,5 @@
       real omegair(L_NSPECTI,naerkind,nsizemax)
       real gir(L_NSPECTI,naerkind,nsizemax)
+!$OMP THREADPRIVATE(QVISsQREF,omegavis,gvis,QIRsQREF,omegair,gir)
 
 
@@ -102,4 +110,5 @@
 
       DOUBLE PRECISION :: radiustab(naerkind,2,nsizemax)
+!$OMP THREADPRIVATE(lamrefir,lamrefvis,radiustab) !nsize read by suaer_corrk
 
 ! Extinction coefficient at reference wavelengths;
@@ -121,4 +130,6 @@
 
       real*8 gweight(L_NGAUSS)
+!$OMP THREADPRIVATE(QREFvis,QREFir,omegaREFvis,omegaREFir,& 	! gweight read by master in sugas_corrk
+		!$OMP tstellar,planckir,PTOP,TAUREF)
 
 !     If the gas optical depth (top to the surface) is less than
@@ -137,4 +148,5 @@
       real*8 glat_ig
       save glat_ig
+!$OMP THREADPRIVATE(Cmk,glat_ig)
 
       ! extinction of incoming sunlight (Saturn's rings, eclipses, etc...)
@@ -143,4 +155,5 @@
       !Latitude-dependent gravity
       REAL, DIMENSION(:), ALLOCATABLE :: glat
+!$OMP THREADPRIVATE(glat,eclipse)
 
       end module radcommon_h
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/radii_mod.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/radii_mod.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/radii_mod.F90	(revision 227)
@@ -12,4 +12,5 @@
       real, save ::  Nmix_h2o
       real, save ::  Nmix_h2o_ice
+!$OMP THREADPRIVATE(rad_h2o,rad_h2o_ice,Nmix_h2o,Nmix_h2o_ice)
       real, parameter ::  coef_chaud=0.13
       real, parameter ::  coef_froid=0.09
@@ -20,5 +21,5 @@
 
 !==================================================================
-   subroutine su_aer_radii(ngrid,reffrad,nueffrad)
+   subroutine su_aer_radii(ngrid,nlayer,reffrad,nueffrad)
 !==================================================================
 !     Purpose
@@ -32,5 +33,6 @@
 !==================================================================
  ! to use  'getin'
-      use ioipsl_getincom 
+!      use ioipsl_getincom 
+      use ioipsl_getincom_p
       use radinc_h, only: naerkind
       use aerosol_mod
@@ -39,13 +41,15 @@
 
       include "callkeys.h"
-      include "dimensions.h"
-      include "dimphys.h"
-
-      integer,intent(in) :: ngrid
-
-      real, intent(out) :: reffrad(ngrid,nlayermx,naerkind)      !aerosols radii (K)
-      real, intent(out) :: nueffrad(ngrid,nlayermx,naerkind)     !variance     
+!      include "dimensions.h"
+!      include "dimphys.h"
+
+      integer,intent(in) :: ngrid
+      integer,intent(in) :: nlayer
+
+      real, intent(out) :: reffrad(ngrid,nlayer,naerkind)      !aerosols radii (K)
+      real, intent(out) :: nueffrad(ngrid,nlayer,naerkind)     !variance     
 
       logical, save :: firstcall=.true.
+!$OMP THREADPRIVATE(firstcall)
       integer :: iaer   
       
@@ -58,26 +62,26 @@
 
             if(iaer.eq.iaero_co2)then ! CO2 ice
-               reffrad(1:ngrid,1:nlayermx,iaer) = 1.e-4
-               nueffrad(1:ngrid,1:nlayermx,iaer) = 0.1 
+               reffrad(1:ngrid,1:nlayer,iaer) = 1.e-4
+               nueffrad(1:ngrid,1:nlayer,iaer) = 0.1 
             endif
 
             if(iaer.eq.iaero_h2o)then ! H2O ice
-               reffrad(1:ngrid,1:nlayermx,iaer) = 1.e-5
-               nueffrad(1:ngrid,1:nlayermx,iaer) = 0.1 
+               reffrad(1:ngrid,1:nlayer,iaer) = 1.e-5
+               nueffrad(1:ngrid,1:nlayer,iaer) = 0.1 
             endif
 
             if(iaer.eq.iaero_dust)then ! dust
-               reffrad(1:ngrid,1:nlayermx,iaer) = 1.e-5
-               nueffrad(1:ngrid,1:nlayermx,iaer) = 0.1 
+               reffrad(1:ngrid,1:nlayer,iaer) = 1.e-5
+               nueffrad(1:ngrid,1:nlayer,iaer) = 0.1 
             endif
  
             if(iaer.eq.iaero_h2so4)then ! H2O ice
-               reffrad(1:ngrid,1:nlayermx,iaer) = 1.e-6
-               nueffrad(1:ngrid,1:nlayermx,iaer) = 0.1 
+               reffrad(1:ngrid,1:nlayer,iaer) = 1.e-6
+               nueffrad(1:ngrid,1:nlayer,iaer) = 0.1 
             endif
 	    
 	    if(iaer.eq.iaero_back2lay)then ! Two-layer aerosols
-               reffrad(1:ngrid,1:nlayermx,iaer) = 2.e-6
-               nueffrad(1:ngrid,1:nlayermx,iaer) = 0.1 
+               reffrad(1:ngrid,1:nlayer,iaer) = 2.e-6
+               nueffrad(1:ngrid,1:nlayer,iaer) = 0.1 
             endif
 
@@ -98,10 +102,10 @@
 	    write(*,*)"radius of H2O water particles:"
             rad_h2o=13. ! default value
-            call getin("rad_h2o",rad_h2o)
+            call getin_p("rad_h2o",rad_h2o)
             write(*,*)" rad_h2o = ",rad_h2o
 
 	    write(*,*)"radius of H2O ice particles:"
             rad_h2o_ice=35. ! default value
-            call getin("rad_h2o_ice",rad_h2o_ice)
+            call getin_p("rad_h2o_ice",rad_h2o_ice)
             write(*,*)" rad_h2o_ice = ",rad_h2o_ice
 
@@ -110,10 +114,10 @@
             write(*,*)"Number mixing ratio of H2O water particles:"
             Nmix_h2o=1.e6 ! default value
-            call getin("Nmix_h2o",Nmix_h2o)
+            call getin_p("Nmix_h2o",Nmix_h2o)
             write(*,*)" Nmix_h2o = ",Nmix_h2o
 
             write(*,*)"Number mixing ratio of H2O ice particles:"
             Nmix_h2o_ice=Nmix_h2o ! default value
-            call getin("Nmix_h2o_ice",Nmix_h2o_ice)
+            call getin_p("Nmix_h2o_ice",Nmix_h2o_ice)
             write(*,*)" Nmix_h2o_ice = ",Nmix_h2o_ice
 	 endif
@@ -126,5 +130,5 @@
 
 !==================================================================
-   subroutine h2o_reffrad(ngrid,pq,pt,reffrad,nueffrad)
+   subroutine h2o_reffrad(ngrid,nlayer,pq,pt,reffrad,nueffrad)
 !==================================================================
 !     Purpose
@@ -141,14 +145,15 @@
 
       include "callkeys.h"
-      include "dimensions.h"
-      include "dimphys.h"
+!      include "dimensions.h"
+!      include "dimphys.h"
       include "comcstfi.h"
 
       integer,intent(in) :: ngrid
-
-      real, intent(in) :: pq(ngrid,nlayermx) !water ice mixing ratios (kg/kg)
-      real, intent(in) :: pt(ngrid,nlayermx) !temperature (K)
-      real, intent(out) :: reffrad(ngrid,nlayermx)      !aerosol radii
-      real, intent(out) :: nueffrad(ngrid,nlayermx) ! dispersion      
+      integer,intent(in) :: nlayer
+
+      real, intent(in) :: pq(ngrid,nlayer) !water ice mixing ratios (kg/kg)
+      real, intent(in) :: pt(ngrid,nlayer) !temperature (K)
+      real, intent(out) :: reffrad(ngrid,nlayer)      !aerosol radii
+      real, intent(out) :: nueffrad(ngrid,nlayer) ! dispersion      
 
       integer :: ig,l
@@ -158,5 +163,5 @@
 
       if (radfixed) then
-         do l=1,nlayermx
+         do l=1,nlayer
             do ig=1,ngrid
                zfice = 1.0 - (pt(ig,l)-T_h2O_ice_clouds) / (T_h2O_ice_liq-T_h2O_ice_clouds)
@@ -167,5 +172,5 @@
          enddo
       else
-         do l=1,nlayermx
+         do l=1,nlayer
             do ig=1,ngrid
                zfice = 1.0 - (pt(ig,l)-T_h2O_ice_clouds) / (T_h2O_ice_liq-T_h2O_ice_clouds)
@@ -186,5 +191,5 @@
 
 !==================================================================
-   subroutine h2o_cloudrad(ngrid,pql,reffliq,reffice)
+   subroutine h2o_cloudrad(ngrid,nlayer,pql,reffliq,reffice)
 !==================================================================
 !     Purpose
@@ -201,12 +206,13 @@
 
       include "callkeys.h"
-      include "dimensions.h"
-      include "dimphys.h"
+!      include "dimensions.h"
+!      include "dimphys.h"
       include "comcstfi.h"
 
       integer,intent(in) :: ngrid
-
-      real, intent(in) :: pql(ngrid,nlayermx) !condensed water mixing ratios (kg/kg)
-      real, intent(out) :: reffliq(ngrid,nlayermx),reffice(ngrid,nlayermx)     !liquid and ice water particle radii (m)
+      integer,intent(in) :: nlayer
+
+      real, intent(in) :: pql(ngrid,nlayer) !condensed water mixing ratios (kg/kg)
+      real, intent(out) :: reffliq(ngrid,nlayer),reffice(ngrid,nlayer)     !liquid and ice water particle radii (m)
 
       real,external :: CBRT            
@@ -214,8 +220,8 @@
 
       if (radfixed) then
-	 reffliq(1:ngrid,1:nlayermx)= rad_h2o
-	 reffice(1:ngrid,1:nlayermx)= rad_h2o_ice
+	 reffliq(1:ngrid,1:nlayer)= rad_h2o
+	 reffice(1:ngrid,1:nlayer)= rad_h2o_ice
       else
-	 do k=1,nlayermx
+	 do k=1,nlayer
 	   do i=1,ngrid
 	     reffliq(i,k) = CBRT(3*pql(i,k)/(4*Nmix_h2o*pi*rhowater))
@@ -234,5 +240,5 @@
 
 !==================================================================
-   subroutine co2_reffrad(ngrid,nq,pq,reffrad)
+   subroutine co2_reffrad(ngrid,nlayer,nq,pq,reffrad)
 !==================================================================
 !     Purpose
@@ -249,12 +255,12 @@
 
       include "callkeys.h"
-      include "dimensions.h"
-      include "dimphys.h"
+!      include "dimensions.h"
+!      include "dimphys.h"
       include "comcstfi.h"
 
-      integer,intent(in) :: ngrid,nq
-
-      real, intent(in) :: pq(ngrid,nlayermx,nq) !tracer mixing ratios (kg/kg)
-      real, intent(out) :: reffrad(ngrid,nlayermx)      !co2 ice particles radii (K)
+      integer,intent(in) :: ngrid,nlayer,nq
+
+      real, intent(in) :: pq(ngrid,nlayer,nq) !tracer mixing ratios (kg/kg)
+      real, intent(out) :: reffrad(ngrid,nlayer)      !co2 ice particles radii (m)
 
       integer :: ig,l
@@ -265,7 +271,7 @@
 
       if (radfixed) then
-         reffrad(1:ngrid,1:nlayermx) = 5.e-5 ! CO2 ice
+         reffrad(1:ngrid,1:nlayer) = 5.e-5 ! CO2 ice
       else
-         do l=1,nlayermx
+         do l=1,nlayer
             do ig=1,ngrid
                zrad = CBRT( 3*pq(ig,l,igcm_co2_ice)/(4*Nmix_co2*pi*rho_co2) )
@@ -281,5 +287,5 @@
 
 !==================================================================
-   subroutine dust_reffrad(ngrid,reffrad)
+   subroutine dust_reffrad(ngrid,nlayer,reffrad)
 !==================================================================
 !     Purpose
@@ -294,13 +300,14 @@
       Implicit none
 
-      include "callkeys.h"
-      include "dimensions.h"
-      include "dimphys.h"
-
-      integer,intent(in) :: ngrid
-
-      real, intent(out) :: reffrad(ngrid,nlayermx)      !dust particles radii (K)
+!      include "callkeys.h"
+!      include "dimensions.h"
+!      include "dimphys.h"
+
+      integer,intent(in) :: ngrid
+      integer,intent(in) :: nlayer
+
+      real, intent(out) :: reffrad(ngrid,nlayer)      !dust particles radii (m)
             
-      reffrad(1:ngrid,1:nlayermx) = 2.e-6 ! dust
+      reffrad(1:ngrid,1:nlayer) = 2.e-6 ! dust
 
    end subroutine dust_reffrad
@@ -309,5 +316,5 @@
 
 !==================================================================
-   subroutine h2so4_reffrad(ngrid,reffrad)
+   subroutine h2so4_reffrad(ngrid,nlayer,reffrad)
 !==================================================================
 !     Purpose
@@ -322,13 +329,14 @@
       Implicit none
 
-      include "callkeys.h"
-      include "dimensions.h"
-      include "dimphys.h"
-
-      integer,intent(in) :: ngrid
-
-      real, intent(out) :: reffrad(ngrid,nlayermx)      !h2so4 particle radii (K)
+!      include "callkeys.h"
+!      include "dimensions.h"
+!      include "dimphys.h"
+
+      integer,intent(in) :: ngrid
+      integer,intent(in) :: nlayer
+
+      real, intent(out) :: reffrad(ngrid,nlayer)      !h2so4 particle radii (m)
                 
-      reffrad(1:ngrid,1:nlayermx) = 1.e-6 ! h2so4
+      reffrad(1:ngrid,1:nlayer) = 1.e-6 ! h2so4
 
    end subroutine h2so4_reffrad
@@ -352,10 +360,10 @@
 
      include "callkeys.h"
-     include "dimensions.h"
-     include "dimphys.h"
-
-      integer,intent(in) :: ngrid
-
-      real, intent(out) :: reffrad(ngrid,nlayermx)      ! particle radii 
+!     include "dimensions.h"
+!     include "dimphys.h"
+
+      integer,intent(in) :: ngrid
+
+      real, intent(out) :: reffrad(ngrid,nlayer)      ! particle radii (m)
       REAL,INTENT(IN) :: pplev(ngrid,nlayer+1) ! inter-layer pressure (Pa)
       INTEGER,INTENT(IN) :: nlayer ! number of atmospheric layers
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/radinc_h.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/radinc_h.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/radinc_h.F90	(revision 227)
@@ -63,5 +63,5 @@
       ! These are set in sugas_corrk
       ! [uses allocatable arrays] -- AS 12/2011
-      integer :: L_NPREF, L_NTREF, L_REFVAR, L_PINT
+      integer :: L_NPREF, L_NTREF, L_REFVAR, L_PINT   !L_NPREF, L_NTREF, L_REFVAR, L_PINT read by master in sugas_corrk
 
       integer, parameter :: L_NGAUSS  = 17
@@ -92,7 +92,9 @@
       character (len=100) :: corrkdir
       save corrkdir
+!$OMP THREADPRIVATE(corrkdir)
 
       character (len=100) :: banddir
       save banddir
+!$OMP THREADPRIVATE(banddir)
 
       end module radinc_h
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/rain.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/rain.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/rain.F90	(revision 227)
@@ -1,6 +1,8 @@
-subroutine rain(ngrid,nq,ptimestep,pplev,pplay,t,pdt,pq,pdq,d_t,dqrain,dqsrain,dqssnow,rneb)
-
-
-  use ioipsl_getincom, only: getin
+subroutine rain(ngrid,nlayer,nq,ptimestep,pplev,pplay,t,pdt,pq,pdq,d_t,dqrain,dqsrain,dqssnow,rneb)
+
+
+! to use  'getin'
+!  use ioipsl_getincom 
+  use ioipsl_getincom_p
   use watercommon_h, only: T_h2O_ice_liq,T_h2O_ice_clouds, RLVTT, RCPD, RCPV, RV, RVTMP2,Psat_water,Tsat_water,rhowater
   use radii_mod, only: h2o_cloudrad
@@ -22,30 +24,31 @@
 !==================================================================
 
-  include "dimensions.h"
-  include "dimphys.h"
+!  include "dimensions.h"
+!  include "dimphys.h"
   include "comcstfi.h"
   include "callkeys.h"
 
 !     Arguments
-      integer,intent(in) :: ngrid ! number of atmospherci columns
+      integer,intent(in) :: ngrid ! number of atmospheric columns
+      integer,intent(in) :: nlayer ! number of atmospheric layers
       integer,intent(in) :: nq ! number of tracers
       real,intent(in) :: ptimestep    ! time interval
-      real,intent(in) :: pplev(ngrid,nlayermx+1) ! inter-layer pressure (Pa)
-      real,intent(in) :: pplay(ngrid,nlayermx)   ! mid-layer pressure (Pa)
-      real,intent(in) :: t(ngrid,nlayermx) ! input temperature (K)
-      real,intent(in) :: pdt(ngrid,nlayermx) ! input tendency on temperature (K/s)      
-      real,intent(in) :: pq(ngrid,nlayermx,nq)  ! tracers (kg/kg)
-      real,intent(in) :: pdq(ngrid,nlayermx,nq) ! input tendency on tracers
-      real,intent(out) :: d_t(ngrid,nlayermx) ! temperature tendency (K/s)
-      real,intent(out) :: dqrain(ngrid,nlayermx,nq) ! tendency of H2O precipitation (kg/kg.s-1)
+      real,intent(in) :: pplev(ngrid,nlayer+1) ! inter-layer pressure (Pa)
+      real,intent(in) :: pplay(ngrid,nlayer)   ! mid-layer pressure (Pa)
+      real,intent(in) :: t(ngrid,nlayer) ! input temperature (K)
+      real,intent(in) :: pdt(ngrid,nlayer) ! input tendency on temperature (K/s)      
+      real,intent(in) :: pq(ngrid,nlayer,nq)  ! tracers (kg/kg)
+      real,intent(in) :: pdq(ngrid,nlayer,nq) ! input tendency on tracers
+      real,intent(out) :: d_t(ngrid,nlayer) ! temperature tendency (K/s)
+      real,intent(out) :: dqrain(ngrid,nlayer,nq) ! tendency of H2O precipitation (kg/kg.s-1)
       real,intent(out) :: dqsrain(ngrid)  ! rain flux at the surface (kg.m-2.s-1)
       real,intent(out) :: dqssnow(ngrid)  ! snow flux at the surface (kg.m-2.s-1)
-      real,intent(in) :: rneb(ngrid,nlayermx) ! cloud fraction
-
-      REAL zt(ngrid,nlayermx)         ! working temperature (K)
-      REAL ql(ngrid,nlayermx)         ! liquid water (Kg/Kg)
-      REAL q(ngrid,nlayermx)          ! specific humidity (Kg/Kg)
-      REAL d_q(ngrid,nlayermx)        ! water vapor increment
-      REAL d_ql(ngrid,nlayermx)       ! liquid water / ice increment
+      real,intent(in) :: rneb(ngrid,nlayer) ! cloud fraction
+
+      REAL zt(ngrid,nlayer)         ! working temperature (K)
+      REAL ql(ngrid,nlayer)         ! liquid water (Kg/Kg)
+      REAL q(ngrid,nlayer)          ! specific humidity (Kg/Kg)
+      REAL d_q(ngrid,nlayer)        ! water vapor increment
+      REAL d_ql(ngrid,nlayer)       ! liquid water / ice increment
 
 !     Subroutine options
@@ -62,8 +65,10 @@
       REAL,PARAMETER :: Kboucher=1.19E8
       REAL,SAVE :: c1
+!$OMP THREADPRIVATE(precip_scheme,rainthreshold,cloud_sat,precip_timescale,Cboucher,c1)
 
       INTEGER,PARAMETER :: ninter=5
 
       logical,save :: evap_prec ! Does the rain evaporate?
+!$OMP THREADPRIVATE(evap_prec)
 
 !     for simple scheme
@@ -73,5 +78,5 @@
 !     Local variables
       INTEGER i, k, n
-      REAL zqs(ngrid,nlayermx),Tsat(ngrid,nlayermx), zdelta, zcor
+      REAL zqs(ngrid,nlayer),Tsat(ngrid,nlayer), zdelta, zcor
       REAL zrfl(ngrid), zrfln(ngrid), zqev, zqevt
 
@@ -80,10 +85,10 @@
       REAL zchau(ngrid),zfroi(ngrid),zfrac(ngrid),zneb(ngrid)
 
-      real reffh2oliq(ngrid,nlayermx),reffh2oice(ngrid,nlayermx)
+      real reffh2oliq(ngrid,nlayer),reffh2oice(ngrid,nlayer)
   
       real ttemp, ptemp, psat_tmp
-      real tnext(ngrid,nlayermx)
-
-      real l2c(ngrid,nlayermx)
+      real tnext(ngrid,nlayer)
+
+      real l2c(ngrid,nlayer)
       real dWtot
 
@@ -92,6 +97,8 @@
       INTEGER, SAVE :: i_vap=0  ! water vapour
       INTEGER, SAVE :: i_ice=0  ! water ice
+!$OMP THREADPRIVATE(i_vap,i_ice)
 
       LOGICAL,SAVE :: firstcall=.true.
+!$OMP THREADPRIVATE(firstcall)
 
 !     Online functions
@@ -114,5 +121,5 @@
          write(*,*) "Precipitation scheme to use?"
          precip_scheme=1 ! default value
-         call getin("precip_scheme",precip_scheme)
+         call getin_p("precip_scheme",precip_scheme)
          write(*,*) " precip_scheme = ",precip_scheme
 
@@ -120,5 +127,5 @@
 	    write(*,*) "rainthreshold in simple scheme?"
             rainthreshold=0. ! default value
-            call getin("rainthreshold",rainthreshold)
+            call getin_p("rainthreshold",rainthreshold)
             write(*,*) " rainthreshold = ",rainthreshold
 
@@ -126,9 +133,9 @@
 	    write(*,*) "cloud water saturation level in non simple scheme?"
             cloud_sat=2.6e-4   ! default value
-            call getin("cloud_sat",cloud_sat)
+            call getin_p("cloud_sat",cloud_sat)
             write(*,*) " cloud_sat = ",cloud_sat
 	    write(*,*) "precipitation timescale in non simple scheme?"
             precip_timescale=3600.  ! default value
-            call getin("precip_timescale",precip_timescale)
+            call getin_p("precip_timescale",precip_timescale)
             write(*,*) " precip_timescale = ",precip_timescale
 
@@ -136,5 +143,5 @@
 	    write(*,*) "multiplicative constant in Boucher 95 precip scheme"
             Cboucher=1.   ! default value
-            call getin("Cboucher",Cboucher)
+            call getin_p("Cboucher",Cboucher)
             write(*,*) " Cboucher = ",Cboucher	
 	    c1=1.00*1.097/rhowater*Cboucher*Kboucher  
@@ -144,5 +151,5 @@
          write(*,*) "re-evaporate precipitations?"
          evap_prec=.true. ! default value
-         call getin("evap_prec",evap_prec)
+         call getin_p("evap_prec",evap_prec)
          write(*,*) " evap_prec = ",evap_prec
 
@@ -151,5 +158,5 @@
 
 !     GCM -----> subroutine variables
-      DO k = 1, nlayermx
+      DO k = 1, nlayer
       DO i = 1, ngrid
 
@@ -172,12 +179,12 @@
 
 !     Initialise the outputs
-      d_t(1:ngrid,1:nlayermx) = 0.0
-      d_q(1:ngrid,1:nlayermx) = 0.0
-      d_ql(1:ngrid,1:nlayermx) = 0.0
+      d_t(1:ngrid,1:nlayer) = 0.0
+      d_q(1:ngrid,1:nlayer) = 0.0
+      d_ql(1:ngrid,1:nlayer) = 0.0
       zrfl(1:ngrid) = 0.0
       zrfln(1:ngrid) = 0.0
 
       ! calculate saturation mixing ratio
-      DO k = 1, nlayermx
+      DO k = 1, nlayer
          DO i = 1, ngrid
             ttemp = zt(i,k) 
@@ -190,5 +197,5 @@
 
       ! get column / layer conversion factor
-      DO k = 1, nlayermx
+      DO k = 1, nlayer
          DO i = 1, ngrid
             l2c(i,k)=(pplev(i,k)-pplev(i,k+1))/g
@@ -199,5 +206,5 @@
       ! We carry the rain with us and calculate that added by warm/cold precipitation
       ! processes and that subtracted by evaporation at each level.
-      DO k = nlayermx, 1, -1
+      DO k = nlayer, 1, -1
 
          IF (evap_prec) THEN ! note no rneb dependence!
@@ -273,5 +280,5 @@
 
  !recalculate liquid water particle radii
-	   call h2o_cloudrad(ngrid,ql,reffh2oliq,reffh2oice)
+	   call h2o_cloudrad(ngrid,nlayer,ql,reffh2oliq,reffh2oice)
 
            SELECT CASE(precip_scheme)
@@ -357,5 +364,5 @@
          endif ! if precip_scheme=1
 
-      ENDDO ! of DO k = nlayermx, 1, -1
+      ENDDO ! of DO k = nlayer, 1, -1
 
 !     Rain or snow on the ground
@@ -376,11 +383,11 @@
 !     now subroutine -----> GCM variables
       if (evap_prec) then
-        dqrain(1:ngrid,1:nlayermx,i_vap)=d_q(1:ngrid,1:nlayermx)/ptimestep
-        d_t(1:ngrid,1:nlayermx)=d_t(1:ngrid,1:nlayermx)/ptimestep
+        dqrain(1:ngrid,1:nlayer,i_vap)=d_q(1:ngrid,1:nlayer)/ptimestep
+        d_t(1:ngrid,1:nlayer)=d_t(1:ngrid,1:nlayer)/ptimestep
       else
-        dqrain(1:ngrid,1:nlayermx,i_vap)=0.0
-        d_t(1:ngrid,1:nlayermx)=0.0
+        dqrain(1:ngrid,1:nlayer,i_vap)=0.0
+        d_t(1:ngrid,1:nlayer)=0.0
       endif
-      dqrain(1:ngrid,1:nlayermx,i_ice) = d_ql(1:ngrid,1:nlayermx)/ptimestep
+      dqrain(1:ngrid,1:nlayer,i_ice) = d_ql(1:ngrid,1:nlayer)/ptimestep
 
     end subroutine rain
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/setspi.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/setspi.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/setspi.F90	(revision 227)
@@ -92,4 +92,5 @@
       endif
     
+!$OMP MASTER    
       nb=0
       ierr=0
@@ -121,4 +122,6 @@
       BWNI(L_NSPECTI)  =lastband(1)
       BWNI(L_NSPECTI+1)=lastband(2)
+!$OMP END MASTER
+!$OMP BARRIER
 
       print*,''
